import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.StringTokenizer;

import com.example.interfaces.Web;

public class WebScanner implements Web {
	private URL url;
	private Map<String, Long> wordCount = new HashMap<String, Long>();
	private int totalWordCount = 0;

	/**
	 * Methods
	 */

	public void setContentWordCount() {
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(
					this.url.openStream()));
			String inputLine;
			Long count;
			while ((inputLine = in.readLine()) != null) {
				StringTokenizer st = new StringTokenizer(inputLine);
				while (st.hasMoreTokens()) {
					String word = st.nextToken().toLowerCase();
					word = modified(word);
					if (null != word) {
						System.out.println("word is: " + word);
						if (null != wordCount.get(word)) {
							count = wordCount.get(word);
							wordCount.put(word, ++count);
						} else {
							count = 1L;
							wordCount.put(word, count);
						}
					}
					totalWordCount++;
				}
			}
			in.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public Long getCountFor(String word) {
		return wordCount.get(word.toLowerCase());
	}

	public String modified(final String input) {
		final StringBuilder builder = new StringBuilder();
		for (final char c : input.toCharArray())
			if (Character.isLetterOrDigit(c))
				builder.append(Character.isLowerCase(c) ? c : Character
						.toLowerCase(c));
		return builder.toString();
	}

	public HashSet<String> getDistinct(String line) {
		StringTokenizer st = new StringTokenizer(line);
		HashSet<String> map = new HashSet<String>();
		while (st.hasMoreTokens()) {
			String word = st.nextToken().toLowerCase();
			map.add(modified(word));
		}
		return map;
	}

	/**
	 * Getters and setters
	 */

	public Map<String, Long> getWordCount() {
		return wordCount;
	}

	public void setWordCount(Map<String, Long> wordCount) {
		this.wordCount = wordCount;
	}

	public WebScanner(String urlPath) throws MalformedURLException {
		this.setUrl(new URL(urlPath));
	}

	public URL getUrl() {
		return url;
	}

	public void setUrl(URL url) {
		this.url = url;
	}

	public int getTotalWordCount() {
		return totalWordCount;
	}

	public void setTotalWordCount(int totalWordCount) {
		this.totalWordCount = totalWordCount;
	}
}
